#pragma once

//#include "AgentUtil.h"
/**
 *	@brief CReplyBase
 */
class CReplyBase
{
public:
	CReplyBase(void)
	{
		m_queryXML_A = NULL;
		m_resultXML_T = NULL;
		m_nResult_len = 0;
	};
	virtual ~CReplyBase(void) {};

protected:
	LPCSTR	m_queryXML_A;
	LPTSTR	m_resultXML_T;
	int		m_nResult_len;
	TCHAR	m_szQueryID[MAX_PATH];

	virtual BOOL DoRequestDetail() = 0;

	void AppendXMLrootHeader()
	{
		ATLASSERT(m_queryXML_A != NULL);
		ATLASSERT(m_resultXML_T != NULL);
		AppendXMLrootHeaderEx(m_resultXML_T, m_nResult_len);
	}

	void AppendXMLrootFooter()
	{
		ATLASSERT(m_queryXML_A != NULL);
		ATLASSERT(m_resultXML_T != NULL);
		AppendXMLrootFooterEx(m_resultXML_T, m_nResult_len);
	}

	void AppendTag(LPCTSTR szTagName, LPCTSTR szTagText)
	{
		ATLASSERT(m_queryXML_A != NULL);
		ATLASSERT(m_resultXML_T != NULL);
		AppendTagEx(szTagName, szTagText, m_resultXML_T, m_nResult_len);
	}

	void AppendLineFeed()
	{
		ATLASSERT(m_queryXML_A != NULL);
		ATLASSERT(m_resultXML_T != NULL);
		AppendLineFeedEx(m_resultXML_T, m_nResult_len);
	}

	BOOL MakeBoolResponseXML(LPCTSTR szQeuryID, BOOL bReponse, NAVERAPP_QUERY_ERROR nErrorCode = NQUERY_ERROR_NONE, 
							 LPCTSTR ErrMsg = NULL)
	{
		ATLASSERT(m_queryXML_A != NULL);
		ATLASSERT(m_resultXML_T != NULL);
		return MakeBoolResponseXMLEx(szQeuryID, bReponse, m_resultXML_T, m_nResult_len, nErrorCode, ErrMsg);
	}



public:
	BOOL	DoRequest(LPCSTR queryXML, LPTSTR szResultXML, int nResult_len)
	{
		m_queryXML_A = queryXML;
		m_resultXML_T = szResultXML;
		m_nResult_len = nResult_len;

		return DoRequestDetail();
	}

	void	SetQueryID(LPCTSTR szID)
	{
		StringCchCopy(m_szQueryID, MAX_PATH, szID);
	}

	static void AppendXMLrootHeaderEx(LPTSTR szResult, int nBuflen);
	static void AppendXMLrootFooterEx(LPTSTR szResult, int nBuflen);
	static void AppendTagEx(LPCTSTR szTagName, LPCTSTR szTagText, LPTSTR szResult, int nBuflen);
	static void AppendLineFeedEx(LPTSTR szResult, int nBuflen);
	static BOOL MakeBoolResponseXMLEx(LPCTSTR szQeuryID, BOOL bReponse, LPTSTR szResult, int nBuflen, 
									  NAVERAPP_QUERY_ERROR nErrorCode = NQUERY_ERROR_NONE, LPCTSTR ErrMsg = NULL); // NS
};

BOOL GetQueryIDnValue(LPCSTR szXML, LPTSTR szQeuryID, int nQueryLen, LPTSTR szValue, int nValueLen);

/**
 *	@brief CReplyAgreementShown
 */
class CReplyAgreementShown : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};

/**
 *	@brief CReplyAgreementIsShow
 */
class CReplyAgreementIsShow : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};

/**
 *	@brief CReplyAgreementURL
 */
class CReplyAgreementURL : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};

/**
 *	@brief CReplyReqGUID
 */
class CReplyReqGUID : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};

/**
 *	@brief CReplyIsInstalled
 */
class CReplyIsInstalled : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};


/**
 *	@brief CReplyUninstallerURL ()
 */
class CReplyUninstallerURL : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};


/**
 *	@brief CReplyVersionLocal
 */
class CReplyVersionLocal : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};

/**
 *	@brief CReplyVersionRecent
 */
class CReplyVersionRecent : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};

/**
 *	@brief CReplyIsChanged
 */
class CReplyIsChanged : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};



/**
 *	@brief CReplyUpgraderRun
 */
class CReplyUpgraderRun : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};



/**
 *	@brief CReplyUpgraderStatus
 */
class CReplyUpgraderStatus : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};


/**
 *	@brief CReplyInstallError
 */
class CReplyInstallError : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};


/**
 *	@brief CReplyUninstallError
 */
class CReplyUninstallError : public CReplyBase
{
public:
	BOOL DoRequestDetail();
};